package jalview.appletgui;

import jalview.jbappletgui.GFontChooser;
import jalview.appletgui.*;
import java.awt.*;
import java.awt.event.*;


public class FontChooser extends GFontChooser
{
  AlignmentPanel ap;
  Font oldFont;
  boolean init = true;
  Frame frame;

  public FontChooser(AlignmentPanel ap, Frame frame)
  {
    super();
    this.frame = frame;

    this.ap = ap;
    String fonts[] = Toolkit.getDefaultToolkit().getFontList();
    for(int i=0; i<fonts.length; i++)
      fontName.addItem(fonts[i]);

    for(int i=1; i<31; i++)
      fontSize.addItem(i+"");

   fontStyle.addItem("plain");
   fontStyle.addItem("bold");
   fontStyle.addItem("italic");

   oldFont = ap.av.getFont();
   fontName.select(oldFont.getName());
   fontSize.select(oldFont.getSize()+"");
   fontStyle.select(oldFont.getStyle());

   init = false;
  }

  protected void ok_actionPerformed(ActionEvent e)
  {
      frame.setVisible(false);
   if(ap.getOverviewPanel()!=null)
     ap.getOverviewPanel().updateOverviewImage();
  }

  protected void cancel_actionPerformed(ActionEvent e)
  {
    ap.av.setFont(oldFont);
    ap.repaint();
    fontName.select(oldFont.getName());
    fontSize.select(oldFont.getSize()+"");
    fontStyle.select(oldFont.getStyle());

    frame.setVisible(false);
  }

  void changeFont()
  {
    Font newFont = new Font(fontName.getSelectedItem().toString(),
                            fontStyle.getSelectedIndex(),
                            Integer.parseInt(fontSize.getSelectedItem().toString())
                            );
    ap.av.setFont(newFont);
    ap.fontChanged();
  }

  protected void fontName_actionPerformed(ItemEvent e)
  {
    if(init) return;
    changeFont();
  }

  protected void fontSize_actionPerformed(ItemEvent e)
  {
    if(init) return;
    changeFont();
  }

  protected void fontStyle_actionPerformed(ItemEvent e)
  {
    if(init) return;
    changeFont();
  }

}
